# Create a blank Makefile for package foo from this template by
# copying the template to (for instance) Foo.mk, them run the following sed
# command twice
#  sed -i Foo.mk -e s/BUSYBOX/FOO/ -e s/busybox/foo/
#
# filename of tarfile
BUSYBOX_ARCHIVE=busybox-1.00-pre1.tar.gz
# directory name that tarfile extracts to
BUSYBOX_DIR=busybox-1.00-pre1

.PHONY: busybox

busybox:	$(BUSYBOX_DIR)/.built

busybox-bin.tgz:	$(BUSYBOX_DIR)/.install
	tar -C $(BUSYBOX_DIR)/_install -czvf - sbin bin > \
		busybox-bin.tgz

$(BUSYBOX_DIR)/.unpacked:	$(BUSYBOX_ARCHIVE)
	tar -xzvf $(BUSYBOX_ARCHIVE)
	touch $(BUSYBOX_DIR)/.unpacked

$(BUSYBOX_DIR)/.patched:	$(BUSYBOX_DIR)/.unpacked
	rm -f $(BUSYBOX_DIR)/.config
	( find $(BUSYBOX_DIR) -name .depend | xargs rm -f )
	patch -p 4 < bb100-pre4-ash.patch
	touch $(BUSYBOX_DIR)/.patched

$(BUSYBOX_DIR)/.configured:	$(BUSYBOX_DIR)/.patched
	( cd $(BUSYBOX_DIR) ; make clean )
	cp busybox-1.00-pre1.config $(BUSYBOX_DIR)/.config
	( cd $(BUSYBOX_DIR) ; make oldconfig )
	touch $(BUSYBOX_DIR)/.configured

$(BUSYBOX_DIR)/.built:	$(BUSYBOX_DIR)/.configured $(GCC3_TARGET)
	( cd $(BUSYBOX_DIR) ; PATH=$(PATH):$(GCC3_PATH) ; make )
	touch $(BUSYBOX_DIR)/.built

$(BUSYBOX_DIR)/.install: $(BUSYBOX_DIR)/.built
	( cd $(BUSYBOX_DIR) ; PATH=$(PATH):$(GCC3_PATH) ; make install)
	touch $(BUSYBOX_DIR)/.install

CLEAN_ALL+=clean_busybox

clean_busybox:
	-( cd $(BUSYBOX_DIR) ; make clean )
	rm -f $(BUSYBOX_DIR)/.built
	rm -f $(BUSYBOX_DIR)/.install

clobber_busybox:
	rm -rf $(BUSYBOX_DIR)
