# Create a blank Makefile for package foo from this template by
# copying the template to (for instance) Foo.mk, them run the following sed
# command twice
#  sed -i Foo.mk -e s/%PKG%/FOO/ -e s/%pkg%/foo/
#
# filename of tarfile
TOOLCHAIN_ARCHIVE=uclibc-toolchain-src-20040609.tar.gz
# directory name that tarfile extracts to
TOOLCHAIN_DIR=uclibc-toolchain-src-20040609

GCC2_TARGET=$(TOOLCHAIN_DIR)/gcc-2.95/.built
GCC2_BIN_DIR=$(TOOLCHAIN_DIR)/gcc-2.95/toolchain_powerpc/bin

GCC3_TARGET=$(TOOLCHAIN_DIR)/gcc-3.3.x/.built
GCC3_BIN_DIR=$(TOOLCHAIN_DIR)/gcc-3.3.x/toolchain_powerpc/bin

.PHONY: gcc2.95 gcc3.3

gcc2.95:	$(GCC2_TARGET)

gcc3.3:	$(GCC3_TARGET)

$(TOOLCHAIN_DIR)/.unpacked:	$(TOOLCHAIN_ARCHIVE)
	tar -xzvf $(TOOLCHAIN_ARCHIVE)
	cp gcc-3.3-make.patch $(TOOLCHAIN_DIR)/gcc-3.3.x/
	cp gcc-2.95-make.patch $(TOOLCHAIN_DIR)/gcc-2.95/
	cp gcc2.95-uclibc-unistd.patch $(TOOLCHAIN_DIR)/gcc-2.95/sources/
	touch $(TOOLCHAIN_DIR)/.unpacked

$(TOOLCHAIN_DIR)/.patched:	$(TOOLCHAIN_DIR)/.unpacked
	( cd $(TOOLCHAIN_DIR)/gcc-2.95 ; patch -p1 < gcc-2.95-make.patch )
	( cd $(TOOLCHAIN_DIR)/gcc-3.3.x ; patch -p1 < gcc-3.3-make.patch )
	touch $(TOOLCHAIN_DIR)/.patched

$(TOOLCHAIN_DIR)/gcc-2.95/.configured:	$(TOOLCHAIN_DIR)/.patched
	touch $(TOOLCHAIN_DIR)/gcc-2.95/.configured

$(TOOLCHAIN_DIR)/gcc-2.95/.built:	$(TOOLCHAIN_DIR)/gcc-2.95/.configured
	( cd $(TOOLCHAIN_DIR)/gcc-2.95 ; make )
	touch $(TOOLCHAIN_DIR)/gcc-2.95/.built

$(TOOLCHAIN_DIR)/gcc-3.3.x/.configured: $(TOOLCHAIN_DIR)/.patched
	touch $(TOOLCHAIN_DIR)/gcc-3.3.x/.configured

$(TOOLCHAIN_DIR)/gcc-3.3.x/.built:	$(TOOLCHAIN_DIR)/gcc-3.3.x/.configured
	( cd $(TOOLCHAIN_DIR)/gcc-3.3.x ;make )
	touch $(TOOLCHAIN_DIR)/gcc-3.3.x/.built

CLEAN_ALL+=clean_toolchain

clean_toolchain:
	-( cd $(TOOLCHAIN_DIR)/gcc-2.95 ; make clean )
	-( cd $(TOOLCHAIN_DIR)/gcc-3.3.x ; make clean )
	rm -f $(TOOLCHAIN_DIR)/gcc-3.3.x/.built
	rm -f $(TOOLCHAIN_DIR)/gcc-2.95/.built

clobber_toolchain:
