# Create a blank Makefile for package foo from this template by
# copying the template to (for instance) Foo.mk, them run the following sed
# command twice
#  sed -i Foo.mk -e s/UBOOT/FOO/ -e s/uboot_tools/foo/
#
# filename of tarfile
UBOOT_ARCHIVE=u-boot.tar.gz
# directory name that tarfile extracts to
UBOOT_DIR=u-boot

MKIMAGE=$(CURDIR)/$(UBOOT_DIR)/tools/mkimage

.PHONY: mkimage

mkimage:	$(MKIMAGE)

$(MKIMAGE):	$(UBOOT_DIR)/.built

$(UBOOT_DIR)/.unpacked:	$(UBOOT_ARCHIVE)
	tar -xzvf $(UBOOT_ARCHIVE)
	touch $(UBOOT_DIR)/.unpacked

$(UBOOT_DIR)/.patched:	$(UBOOT_DIR)/.unpacked
	( cd $(UBOOT_DIR); \
		find . -name .depend |xargs rm \
		rm -f include/bmp_logo.h u-boot.* System.map \
		)
	patch -p 0 <u-boot-tools.patch
	touch $(UBOOT_DIR)/.patched

$(UBOOT_DIR)/.configured:	$(UBOOT_DIR)/.patched
	( cd $(UBOOT_DIR) ; make Sandpoint8245_config )
	touch $(UBOOT_DIR)/.configured

$(UBOOT_DIR)/.built:	$(UBOOT_DIR)/.configured $(GCC3_TARGET)
	( cd $(UBOOT_DIR) ;  PATH=$(PATH):$(GCC3_PATH) ; make u-boot )
	touch $(UBOOT_DIR)/.built

CLEAN_ALL+=clean_uboot_tools

clean_uboot_tools:
	-( cd $(UBOOT_DIR) ; make clean )
	rm -f $(UBOOT_DIR)/.built

clobber_uboot_tools:
