#ifndef __FW_H__
#define __FW_H__

#define FW_VERSION	0
#define FW_REVISION	3

/* Firmware File Header */
struct	FW_header {
	u_int32_t	start_1;	/* start of first section (kernel) */
	u_int32_t	size_1;		/* size of first section */
	u_int32_t	start_2;	/* start of second section (root fs) */
	u_int32_t	size_2;
	u_int32_t	start_3;	/* start of third section (unused) */
	u_int32_t	size_3;
	u_int32_t	checksum_1;	/* checksum of first section */
	u_int32_t	checksum_2;
	u_int32_t	checksum_3;
	u_char		magic[12];	/* Magic number for Firmware File */
	u_char		productId;
	u_char		customId;
	u_char		modelId;
	u_char		reserved_1[1+8];	/* fill to 64 bytes */
	u_int32_t	Next;
};

u_int32_t cksum_section( char *, u_int32_t, u_int32_t );

#endif
