#!/bin/sh

mount -o remount -w %root% /

#custom info link
ln -s /sys/crfs/codepages /etc/samba/codepages
#ln -s /sys/crfs/etc_codepage/codepage /etc/codepage
ln -s /sys/crfs/web_page /web/web
ln -s /sys/crfs/upnp/upnpscript /bin/upnpscript
ln -s /sys/crfs/default /default

# --start-- beattie modifications
set -x
mount -t proc proc /proc
mount -o loop /image.cfs /sys/crfs
sleep 1
insmod /sys/crfs/usb/usb-storage.o
insmod /sys/crfs/usb/ehci-hcd.o
insmod /sys/crfs/usb/usb-ohci.o
sleep 5
mkdir /newroot
mount -L DSMG600_KEY /newroot
sleep 5
ls -l /newroot
if [ -x /newroot/.DSM-G600-USB-KEY-init ] ; then
	exec /newroot/.DSM-G600-USB-KEY-init
fi
umount /newroot
rmdir /newroot
uount /sys/cfs
#rmmod usb-ohci ehci-hcd usb-storage
set +x
# ---end--- beattie modifications

/usr/sbin/mtd_check

mount -a

if [ ! -f /sys/mtd1/v2.3 ]; then
	echo "** copy default config files"
	#rm -f /sys/mtd1/v*.*
	#cp -R /sys/crfs/default/* /sys/mtd1/.
	/bin/chkmtdversion
fi

echo "** mount mtd2"
mount -t minix /dev/mtdblock1 /sys/mtd2
if [ ! -f /sys/mtd2/v2.3 ]; then
	echo "** copy default config files to mtd2"
	#rm -f /sys/mtd2/v*.*
	#cp -R /sys/crfs/default/* /sys/mtd2/.
	#/bin/chkmtdversion
fi
umount /sys/mtd2
echo "** umount mtd2"

echo "** copy mtd1 files"
cp -f /sys/mtd1/hosts /etc/hosts
cp -f /sys/mtd1/rc.init.sh /etc/rc.d/rc.init.sh
cp -f /sys/mtd1/resolv.conf /etc/resolv.conf
cp -f /sys/mtd1/passwd /etc/passwd
cp -f /sys/mtd1/shadow /etc/shadow
cp -f /sys/mtd1/group /etc/group
cp -f /sys/mtd1/sib.conf /web/sib.conf
cp -f /sys/mtd1/sib2.conf /web/sib2.conf
cp -f /sys/mtd1/sib_ap.conf /web/sib_ap.conf
cp -f /sys/mtd1/smbpasswd /etc/samba/smbpasswd
cp -f /sys/mtd1/smb.default /etc/samba/smb.default
#cp -f /sys/mtd1/rtc.conf /etc/rtc.conf
cp -f /sys/mtd1/email.conf /etc/email.conf
cp -f /sys/mtd1/log.conf /web/log.conf
cp -f /sys/mtd1/language.conf /web/language.conf
cp -f /sys/mtd1/upnpav.conf /etc/upnpav.conf
cp -f /sys/mtd1/ftpaccess /etc/
cp -f /sys/mtd1/firmwareupdate /tmp/
cp -f /sys/mtd1/codepage /etc/codepage
rm -f /sys/mtd1/firmwareupdate
mv /sys/mtd1/restore /tmp/
umount /sys/mtd1

rm -rf /default
mkdir /default
cp -f /sys/crfs/default/* /default/

echo "** soft-link modules"
ln -s /sys/crfs/usb/usb-storage.o /lib/modules/usb-storage.o
ln -s /sys/crfs/usb/ehci-hcd.o /lib/modules/ehci-hcd.o
ln -s /sys/crfs/usb/usb-ohci.o /lib/modules/usb-ohci.o

ln -s /sys/crfs/samba /usr/sbin/samba
ln -s /usr/sbin/samba/liblib.so.0.0.0 /lib/liblib.so.0
ln -s /usr/sbin/samba/libubiqx.so.0.0.0 /lib/libubiqx.so.0
ln -s /usr/sbin/samba/libparam.so.0.0.0 /lib/libparam.so.0
ln -s /usr/sbin/samba/libsmb.so.0.0.0 /lib/libsmb.so.0
ln -s /usr/sbin/samba/libpassdb.so.0.0.0 /lib/libpassdb.so.0
ln -s /sys/crfs/web/webs /web/webs
ln -s /sys/crfs/web/S_DOWN /web/S_DOWN
ln -s /sys/crfs/samba/smbpasswd /bin/smbpasswd
ln -s /sys/crfs/samba/smb /bin/smb
ln -s /sys/crfs/samba/smbcom /bin/smbcom
ln -s /sys/crfs/samba/smbd /bin/smbd
ln -s /sys/crfs/samba/nmbd /bin/nmbd
ln -s /sys/crfs/samba/smbclient /bin/smbclient
ln -s /sys/crfs/bin/ftpd /bin/ftpd
ln -s /sys/crfs/bin/wget /bin/wget
ln -s /sys/crfs/bin/at /bin/at
ln -s /sys/crfs/bin/atd /bin/atd
#ln -s /sys/crfs/bin/dosfsck /bin/dosfsck #+Wilson08312006
#ln -s /sys/crfs/bin/fdisk /bin/fdisk #+Wilson08312006
ln -s /sys/crfs/bin/judge_swap /bin/judge_swap
#ln -s /sys/crfs/bin/mkfs.vfat /bin/mkfs.vfat #+Wilson08312006
#ln -s /sys/crfs/bin/e2fsck /bin/e2fsck #+Wilson08312006
#ln -s /sys/crfs/bin/mke2fs /bin/mke2fs #+Wilson08312006
ln -s /bin/at /bin/atq
ln -s /bin/at /bin/atrm
ln -s /sys/crfs/bin/imgconvert /bin/imgconvert
ln -s /sys/crfs/bin/chk_upnpav_path /bin/chk_upnpav_path
 
#customer information
ln -s /sys/crfs/shared_name /sys/custom/shared_name
ln -s /sys/crfs/default /sys/custom/default
ln -s /sys/crfs/web_page /sys/custom/web_page
ln -s /sys/crfs/codepages /sys/custom/codepages
ln -s /sys/crfs/etc_codepage /sys/custom/etc_codepage
ln -s /sys/crfs/upnp /sys/custom/upnp
ln -s /sys/crfs/default/version.txt /sys/custom/version/version.txt
ln -s /sys/crfs/default/version2.txt /sys/custom/version/version2.txt

#+Wilson07192005
# for WCN 
mkdir /sys/custom/wcn
ln -s /sys/crfs/wcn/xmlparser /usr/sbin/xmlparser
ln -s /sys/crfs/wcn/macaddr.wfc /sys/custom/wcn/macaddr.wfc
#Wilson07192005+

echo "** set loopback interface"
/sbin/ifconfig lo 127.0.0.1 netmask 255.0.0.0

#+Wilson08022004
#
# Ethernet Bridge Setup
#

#/usr/sbin/brctl addbr br0			#+Wilson01242005
#/usr/sbin/brctl addif br0 eth0		#+Wilson01242005
#Wilson08022004+

#+Wilson01242005
#
# Enable Bonding Driver
#
# mode 1: active backup, miimonitor=100ms, primary interface=eth0
insmod /sys/crfs/bridge/bonding.o mode=1 miimon=100 primary=eth0	#+Wilson05092005
/sbin/ifconfig br0 192.168.1.2 netmask 255.255.255.0 

#
# Enslave Ethernet interface eth0
#

/usr/sbin/mac_read /dev/mtdblock3 eth0
/sbin/ifenslave br0 eth0	

echo 0 > /proc/sys/net/ipv4/ip_forward
#/sbin/ifconfig br0 192.168.1.2 netmask 255.255.255.0	#+Wilson01242005

echo "** execute rc.init.sh"
/bin/chg_hostname
/etc/rc.d/rc.init.sh

#echo 30 > /proc/sys/net/ipv4/tcp_keepalive_time

/bin/judge_swap	#+Wilson04282005

/usr/sbin/chkbutton 
/web/webs &
#/bin/wireless & 
/bin/atd
/bin/smbcom
smbd -D
nmbd -D
autoip br0
goweb br0 /mnt/web_page/goweb.htm
goweb br0:0 /mnt/web_page/goweb-autoip.htm
SetTimeZone
stime
/usr/sbin/ppc_rtc -b
crond

/bin/cat /sys/crfs/default/version.txt

echo "** insert USB Host Controller modules"
insmod /lib/modules/ehci-hcd.o
insmod /lib/modules/usb-ohci.o

#+Wilson05112005
#if [ -e /proc/scsi/atp86x ]; then
#	insmod /lib/modules/usb-storage.o host_number=1		#IDE HDD exist
#else		
#	insmod /lib/modules/usb-storage.o host_number=0		#no IDE HDD
#fi
#Wilson05112005+

/bin/op_server &
route add -net 224.0.0.0 netmask 255.0.0.0 dev br0
/usr/sbin/mfg_search
/bin/upnpscript

#+Wilson07192005
ehco "** Get MAC Addr for WCN"
MACStrStart=39
MACStrOffset=17
LANMACStr=$(ifconfig eth0 | grep HWaddr)
lanmac=`expr substr "$LANMACStr" "$MACStrStart" "$MACStrOffset"`
echo "$lanmac" > /etc/macaddr	#+Wilson12272004
#Wilson07192005+

#+Wilson05102005
echo "** load wireless driver"
insmod /sys/crfs/wireless/rt2500.o	

#
# Enslave Wireless interface ra0
#
Ralink=$(ifconfig ra0 | grep ra0)
if [ -n "$Ralink" ]; then
	#	
	# Add Wireless interface to Ethernet Bridge 
	#	
	#/usr/sbin/brctl addif br0 ra0	#+Wilson01242005

	#	
	# Enable Ethernet interface
 	#
	#/sbin/ifconfig eth0 0.0.0.0	#+Wilson01242005

	#+Wilson04222004
	#
	# Make sure the LAN's Mac Addr == WLAN's Mac Addr
	#	
	#MACStrStart=39
	#MACStrOffset=17
	#LANMACStr=$(ifconfig adm0 | grep HWaddr)
	#WLANMACStr=$(ifconfig ra0 | grep HWaddr)
	#lanmac=`expr substr "$LANMACStr" "$MACStrStart" "$MACStrOffset"`
	#wlanmac=`expr substr "$WLANMACStr" "$MACStrStart" "$MACStrOffset"`
	
	#if [ "$lanmac" != "$wlanmac" ]; then
	#	ifconfig ra0 hw ether "$lanmac"
	#fi

	#/sbin/ifconfig ra0 0.0.0.0		#+Wilson01242005
	#
	# Enslave Wireless interface ra0
	#
	/sbin/ifenslave br0 ra0				#+Wilson01242005, enslave ra0, eth0
	touch /etc/wlan						#+Wilson08202004
fi
#Wilson05102005+

/bin/wireless
touch /tmp/boot_finished
/usr/sbin/chk_fun_plug &
/bin/chk_upnpav_path &
